local Shrubbery = foundation.createMod();

Shrubbery:dofile("monuments.lua")

Shrubbery:registerEnumValue ("BUILDING_PART_TYPE", "DECO")

Shrubbery:registerAssetId("models/core.fbx/Materials/blank1", "BLANK_CORE_MATERIAL")
Shrubbery:registerAssetId("models/shrubbery.fbx/Materials/officinalgarden", "OFFICINALGARDEN")
Shrubbery:registerAssetId("models/shrubbery.fbx/Materials/bushescolor", "BUSHESCOLOR")
Shrubbery:registerAssetId("models/shrubbery.fbx/Materials/oak", "OAK")
Shrubbery:registerAssetId("models/shrubbery.fbx/Materials/vine", "VINE")

Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush01Low", "PREFAB_BUSH01LOW")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush01Med", "PREFAB_BUSH01MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush01Large", "PREFAB_BUSH01LARGE")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush02Low", "PREFAB_BUSH02LOW")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush02Med", "PREFAB_BUSH02MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush02Large", "PREFAB_BUSH02LARGE")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush03Low", "PREFAB_BUSH03LOW")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush03Med", "PREFAB_BUSH03MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush03Large", "PREFAB_BUSH03LARGE")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush04Low", "PREFAB_BUSH04LOW")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush04Med", "PREFAB_BUSH04MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush04Large", "PREFAB_BUSH04LARGE")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Bush05Low", "PREFAB_BUSH05LOW")

Shrubbery:registerAssetProcessor("models/core.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Shrubbery:registerAssetProcessor("models/shrubbery.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})


Shrubbery:override({
    Id = "BLANK_CORE_MATERIAL",
	HasAlphaTest = true
})
Shrubbery:override({
    Id = "OFFICINALGARDEN",
	HasAlphaTest = true,
	BackFaceVisible = true
})
Shrubbery:override({
    Id = "BUSHESCOLOR",
	HasAlphaTest = true,
	BackFaceVisible = true
})
Shrubbery:override({
    Id = "OAK",
	HasAlphaTest = true,
	BackFaceVisible = true
})
Shrubbery:override({
    Id = "VINE",
	HasAlphaTest = true,
	BackFaceVisible = true
})

Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH01LOW",
	Name = "BUSH01LOW_NAME",
	Description = "BUSH01LOW_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH01LOW"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH01MED",
	Name = "BUSH01MED_NAME",
	Description = "BUSH01MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH01MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH01LARGE",
	Name = "BUSH01LARGE_NAME",
	Description = "BUSH01LARGE_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH01LARGE"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH02LOW",
	Name = "BUSH02LOW_NAME",
	Description = "BUSH02LOW_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH02LOW"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH02MED",
	Name = "BUSH02MED_NAME",
	Description = "BUSH02MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH02MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH02LARGE",
	Name = "BUSH02LARGE_NAME",
	Description = "BUSH02LARGE_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH02LARGE"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH03LOW",
	Name = "BUSH03LOW_NAME",
	Description = "BUSH03LOW_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH03LOW"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH03MED",
	Name = "BUSH03MED_NAME",
	Description = "BUSH03MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH03MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH03LARGE",
	Name = "BUSH03LARGE_NAME",
	Description = "BUSH03LARGE_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH03LARGE"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH04LOW",
	Name = "BUSH04LOW_NAME",
	Description = "BUSH04LOW_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH04LOW"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH04MED",
	Name = "BUSH04MED_NAME",
	Description = "BUSH04MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH04MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH04LARGE",
	Name = "BUSH04LARGE_NAME",
	Description = "BUSH04LARGE_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH04LARGE"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "BUSH05LOW",
	Name = "BUSH05LOW_NAME",
	Description = "BUSH05LOW_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUSH05LOW"
	}
})


--TREES -------------------------------------------------------------------------------------
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Tree01Med", "PREFAB_TREE01MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Tree02Med", "PREFAB_TREE02MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Tree03Med", "PREFAB_TREE03MED")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Tree04Med", "PREFAB_TREE04MED")

Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "TREE01MED",
	Name = "TREE01MED_NAME",
	Description = "TREE01MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE01MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "TREE02MED",
	Name = "TREE02MED_NAME",
	Description = "TREE02MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE02MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "TREE03MED",
	Name = "TREE03MED_NAME",
	Description = "TREE03MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE03MED"
	}
})
Shrubbery:register({
	DataType = "BUILDING_PART",
	Id = "TREE04MED",
	Name = "TREE04MED_NAME",
	Description = "TREE04MED_DESC",
	Category = "DECO",
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = {
					{0.2, 0.2},
					{0.2, -0.2},
					{-0.2, -0.2},
					{-0.2, 0.2}
				}
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE04MED"
	}
})


--WALLS/FENCES -------------------------------------------------------------------------------------
Shrubbery:registerAssetId("models/fence.png", "TEXTURE_FENCE")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Fence_Bush01", "PREFAB_FENCE_BUSH01")
Shrubbery:registerAssetId("models/shrubbery.fbx/Prefab/Fence_Lattice01", "PREFAB_FENCE_LATTICE01")

Shrubbery:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_FENCE",
	HasAlphaTest = true,
	AlbedoTexture = "TEXTURE_FENCE"
})

Shrubbery:register({
	DataType = "WALL_CONFIG",
	Id = "FENCE_BUSH01",
	WallConfigName = "FENCE_BUSH01_NAME",
	IsManuallyUnlocked = false,
	Material = "MATERIAL_FENCE",
	MaterialTop = "MATERIAL_FENCE",
	Crenation = "PREFAB_FENCE_BUSH01",
	CrenationDistance = 3.4,
	StepLength = 3,
	Width = 0.5,
	Height = 2,
	UvTillingWall = 0.2,
	UvTillingTop = 0.2,
	WallOffsetY = 0,
	CrenationOffsetY = 0,
	CrenationOffsetZ = 0
})
Shrubbery:register({
	DataType = "WALL_CONFIG",
	Id = "FENCE_LATTICE01",
	WallConfigName = "FENCE_LATTICE01_NAME",
	IsManuallyUnlocked = false,
	Material = "MATERIAL_FENCE",
	MaterialTop = "MATERIAL_FENCE",
	Crenation = "PREFAB_FENCE_LATTICE01",
	CrenationDistance = 3.4,
	StepLength = 3,
	Width = 0.5,
	Height = 2,
	UvTillingWall = 0.2,
	UvTillingTop = 0.2,
	WallOffsetY = 0,
	CrenationOffsetY = 0,
	CrenationOffsetZ = 0
})